//-----------------------------------------------------------------------------
// 
// 		cwCu		WindowsOSpBaseImagevO
// 
//  	Ver 3.24d
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define DX_MAKE

#include "../DxCompileConfig.h"

// CN[h ---------------------------------------------------------------
#include "DxBaseImageWin.h"
#include "DxGuid.h"
#include "DxWinAPI.h"
#include "../DxFile.h"
#include "../DxBaseFunc.h"
#include "../DxMemory.h"
#include "../DxBaseImage.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N` -----------------------------------------------------------------

// \̐錾 -----------------------------------------------------------------

typedef struct tagBASEIMAGEMANAGE_WIN
{
	D_IWICImagingFactory *WICImagingFactory ;
} BASEIMAGEMANAGE_WIN ;

// ֐錾 -------------------------------------------------------------------

static	int LoadWICProcess( STREAMDATA *Src, BASEIMAGE *BaseImage, int GetFormatOnly ) ;						// WICɂǂݍ

// f[^` -----------------------------------------------------------------

int ( *DefaultImageLoadFunc_PF[] )( STREAMDATA *Src, BASEIMAGE *BaseImage, int GetFormatOnly ) =
{
	LoadWICProcess ,
	NULL
} ;

BASEIMAGEMANAGE_WIN BaseImageManageWin ;

// vO -----------------------------------------------------------------

// ˑEI֐

// {C[WǗ̊ˑ̏
extern int InitializeBaseImageManage_PF( void )
{
	// IWICImagingFactory ̐
	WinAPIData.Win32Func.CoCreateInstanceFunc( CLSID_WICIMAGINGFACTORY, NULL, CLSCTX_INPROC_SERVER, IID_IWICIMAGINGFACTORY, ( void ** )&BaseImageManageWin.WICImagingFactory ) ;

	// ˑ̓ǂݍ݊֐͌Ɏs悤ɂ
	BASEIM.PlatformLoadFunctionAfterFlag = TRUE ;

	// I
	return 0 ;
}

// {C[WǗ̊ˑ̌n
extern int TerminateBaseImageManage_PF( void )
{
	// IWICImagingFactory ̉
	if( BaseImageManageWin.WICImagingFactory != NULL )
	{
		BaseImageManageWin.WICImagingFactory->Release() ;
		BaseImageManageWin.WICImagingFactory = NULL ;
	}

	// I
	return 0 ;
}

// WICɂǂݍ
static int LoadWICProcess( STREAMDATA *Src, BASEIMAGE *BaseImage, int GetFormatOnly )
{
	HRESULT hr ;
	D_IWICStream *WICStream ;
	D_IWICBitmapDecoder *WICBitmapDecoder = NULL ;
	D_IWICBitmapFrameDecode *WICBitmapFrameDecode = NULL ;
	D_IWICFormatConverter *WICFormatConverter = NULL ;
	D_WICPixelFormatGUID WICPixelFormatGUID ;
	BYTE *SrcP = NULL ;
	size_t FileBytes ;
	int UseConvert = FALSE ;

	// IWICImagingFactory ȂΉI
	if( BaseImageManageWin.WICImagingFactory == NULL )
	{
		return -1 ;
	}

	// ɓǂݍ܂ꂽf[^ł͂Ȃꍇ͏Ȃ
	if( GetMemStreamDataShredStruct()->Read != Src->ReadShred.Read )
	{
		return -1 ;
	}

	// ̓ǂݍ܂ꂽf[^̃AhX擾
	SrcP = *( ( BYTE ** )Src->DataPoint ) ;
	FileBytes = *( ( size_t * )( ( BYTE ** )Src->DataPoint + 1 ) ) ;

	// IWICStream ̍쐬ƃZbgAbv
	hr = BaseImageManageWin.WICImagingFactory->CreateStream( &WICStream ) ;
	if( FAILED( hr ) )
	{
		goto ERR ;
	}
	hr = WICStream->InitializeFromMemory( SrcP, ( DWORD )FileBytes ) ;
	if( FAILED( hr ) )
	{
		goto ERR ;
	}

    // fR[_[̍쐬
	hr = BaseImageManageWin.WICImagingFactory->CreateDecoderFromStream( WICStream, NULL, D_WICDecodeMetadataCacheOnDemand, &WICBitmapDecoder ) ;
	if( FAILED( hr ) )
	{
		goto ERR ;
	}

	// t[̎擾
	hr = WICBitmapDecoder->GetFrame( 0, &WICBitmapFrameDecode );
	if( FAILED( hr ) )
	{
		goto ERR ;
	}

	// TCY̎擾
	hr = WICBitmapFrameDecode->GetSize( ( UINT * )&BaseImage->Width, ( UINT * )&BaseImage->Height ) ;
	if( FAILED( hr ) )
	{
		goto ERR ;
	}

	// sNZtH[}bg̎擾
	hr = WICBitmapFrameDecode->GetPixelFormat( &WICPixelFormatGUID ) ;
	if( FAILED( hr ) )
	{
		goto ERR ;
	}

	// sNZtH[}bg̔
	if( _MEMCMP( &WICPixelFormatGUID, &GUID_WICPIXELFORMAT32bppBGRA, sizeof( GUID ) ) == 0 )
	{
		NS_CreateARGB8ColorData( &BaseImage->ColorData ) ;
	}
	else
	if( _MEMCMP( &WICPixelFormatGUID, &GUID_WICPIXELFORMAT32bppRGBA, sizeof( GUID ) ) == 0 )
	{
		NS_CreateABGR8ColorData( &BaseImage->ColorData ) ;
	}
	else
	if( _MEMCMP( &WICPixelFormatGUID, &GUID_WICPIXELFORMAT32bppBGR, sizeof( GUID ) ) == 0 )
	{
		NS_CreateXRGB8ColorData( &BaseImage->ColorData ) ;
	}
	else
	if( _MEMCMP( &WICPixelFormatGUID, &GUID_WICPIXELFORMAT32bppRGB, sizeof( GUID ) ) == 0 )
	{
		NS_CreateColorData( &BaseImage->ColorData, 32, 0x0000ff, 0x00ff00, 0xff0000, 0, 0, 0, FALSE ) ;
	}
	else
	if( _MEMCMP( &WICPixelFormatGUID, &GUID_WICPIXELFORMAT24bppBGR, sizeof( GUID ) ) == 0 )
	{
		NS_CreateFullColorData( &BaseImage->ColorData ) ;
	}
	else
	if( _MEMCMP( &WICPixelFormatGUID, &GUID_WICPIXELFORMAT24bppRGB, sizeof( GUID ) ) == 0 )
	{
		NS_CreateBGR8ColorData( &BaseImage->ColorData ) ;
	}
	else
	{
		UseConvert = TRUE ;

		// Ή̃tH[}bg̏ꍇ̓Ro[g
		NS_CreateARGB8ColorData( &BaseImage->ColorData ) ;
	}

	// 摜ۑ郁̈̊m
	BaseImage->Pitch = BaseImage->ColorData.PixelByte * BaseImage->Width ;
	BaseImage->GraphData = DXALLOC( BaseImage->Pitch * BaseImage->Height ) ;
	if( BaseImage->GraphData == NULL )
	{
		goto ERR ;
	}
	BaseImage->MipMapCount    = 0 ;
	BaseImage->GraphDataCount = 0 ; 

	// Ro[g邩ǂŏ𕪊
	if( UseConvert )
	{
		BOOL CanConvertResult = FALSE ;

		// ARGB8 tH[}bgɃRo[g
		NS_CreateARGB8ColorData( &BaseImage->ColorData ) ;

		// Ro[^[̍쐬
		hr = BaseImageManageWin.WICImagingFactory->CreateFormatConverter( &WICFormatConverter ) ;
		if( FAILED( hr ) )
		{
			goto ERR ;
		}

		// Ro[g\`FbN
		hr = WICFormatConverter->CanConvert( WICPixelFormatGUID, GUID_WICPIXELFORMAT32bppBGRA, &CanConvertResult ) ;
		if( FAILED( hr ) || CanConvertResult == FALSE )
		{
			goto ERR ;
		}

		// Ro[^[̏
		hr = WICFormatConverter->Initialize( WICBitmapFrameDecode, GUID_WICPIXELFORMAT32bppBGRA, D_WICBitmapDitherTypeErrorDiffusion, NULL, 0, D_WICBitmapPaletteTypeMedianCut ) ;
		if( FAILED( hr ) )
		{
			goto ERR ;
		}

		// sNZ擾
		hr = WICFormatConverter->CopyPixels( NULL, BaseImage->Pitch, BaseImage->Pitch * BaseImage->Height, ( BYTE * )BaseImage->GraphData ) ;
		if( FAILED( hr ) )
		{
			goto ERR ;
		}
	}
	else
	{
		// sNZ擾
		hr = WICBitmapFrameDecode->CopyPixels( NULL, BaseImage->Pitch, BaseImage->Pitch * BaseImage->Height, ( BYTE * )BaseImage->GraphData ) ;
		if( FAILED( hr ) )
		{
			goto ERR ;
		}
	}

	if( WICFormatConverter != NULL )
	{
		WICFormatConverter->Release() ;
		WICFormatConverter = NULL ;
	}

	if( WICBitmapFrameDecode != NULL )
	{
		WICBitmapFrameDecode->Release() ;
		WICBitmapFrameDecode = NULL ;
	}

	if( WICBitmapDecoder != NULL )
	{
		WICBitmapDecoder->Release() ;
		WICBitmapDecoder = NULL ;
	}

	if( WICStream != NULL )
	{
		WICStream->Release() ;
		WICStream = NULL ;
	}

	// I
	return 0 ;

ERR :

	if( BaseImage->GraphData != NULL )
	{
		DXFREE( BaseImage->GraphData ) ;
		BaseImage->GraphData = NULL ;
	}

	if( WICFormatConverter != NULL )
	{
		WICFormatConverter->Release() ;
		WICFormatConverter = NULL ;
	}

	if( WICBitmapFrameDecode != NULL )
	{
		WICBitmapFrameDecode->Release() ;
		WICBitmapFrameDecode = NULL ;
	}

	if( WICBitmapDecoder != NULL )
	{
		WICBitmapDecoder->Release() ;
		WICBitmapDecoder = NULL ;
	}

	if( WICStream != NULL )
	{
		WICStream->Release() ;
		WICStream = NULL ;
	}

	// G[I
	return -1 ;
}

#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

